﻿using System;

public partial class FactoryMethod : System.Web.UI.Page
{
    //客户端调用(Client-Side)。
    protected void Page_Load(object sender, EventArgs e)
    {
        //客户端程序调用的时候，只要改右侧创建实体的类型即可
        IFactory factory1 = new 博派Factory();
        变形金刚 擎天柱 = factory1.createTransformer();
        擎天柱.transformCar();

        //把职责委托给平行层次中的子类
        IFactory factory2 = new 狂派Factory();
        变形金刚 威震天 = factory2.createTransformer();
        威震天.transformAirplane();
    }
}

//IProduct
class 变形金刚
{
    public virtual void transformCar()
    {
        Console.WriteLine("变汽车");
    }

    public virtual void transformAirplane()
    {
        Console.WriteLine("变飞机");
    }

    public virtual void transformAnimal()
    {
        Console.WriteLine("变动物");
    }
}

//IProduct 的子类
class 博派 : 变形金刚
{ }

//IProduct 的子类
class 狂派 : 变形金刚
{ }


//变形金刚工厂 (亦可用抽象类)
interface IFactory
{
    //隐藏实现细节。
    //事前不知道要创建哪种变形金刚，延至「客户端」中实现。
    变形金刚 createTransformer();
}

//博派的工厂 (由此种子类来决定具体实例化哪种类型)
class 博派Factory : IFactory
{
    public 变形金刚 createTransformer()
    {
        return new 博派();
    }
}

//狂派的工厂 (由此种子类来决定具体实例化哪种类型)
class 狂派Factory : IFactory
{
    public 变形金刚 createTransformer()
    {
        return new 狂派();
    }
}

//以后引进新产品 (堕落金刚) 时，我们不需要冒险修改既有的「工厂类」，而只要添加新的产品类、新的工厂类，
//最后由 IFactory 的子类，以及客户端程序 (Page_Load 方法)，来决定要创建哪些具体类型；
//整个架构变成只有「扩展」的变化，而不再有「修改」的变化。

//若要修改旧功能，如狂派类，要加入组合成「大力神」的功能时，也只需要修改既有的「狂派」类。